
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;###############################################################################################

        .DATA

hUsr           dd 0
ClassName      db 'dTestPmClass',0
AppName        db 'dTest PM Window',0
MsgStr         db 'CmdLine From Window 1',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance      dd ?
hWin           dd ?
lpCmndLineFull dd ?
lpCmndLine     dd ?

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                     ;ECX = uMsg
        cmp     ecx,WM_CLOSE
        jz      WndPrX

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret     16

;------------------------------

;WM_CLOSE

WndPrX: mov     ecx,hUsr
        jecxz   WndPrY

        INVOKE  PostMessage,ecx,WM_SYSCOMMAND,SC_CLOSE,NULL

WndPrY: INVOKE  DestroyWindow,[esp+4]            ;hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

_main   PROC

;------------------------------

        xor     edi,edi
        INVOKE  GetCommandLine
        mov     ecx,edi
        mov     dx,2220h                       ;double quote and space
        mov     lpCmndLineFull,eax

Start0: cmp     cl,dh                          ;double quote
        jnz     Start2

Start1: mov     cl,[eax]
        jecxz   Start4

        inc     eax
        cmp     cl,dh                          ;double quote
        jnz     Start1

Start2: mov     cl,[eax]
        jecxz   Start4

        inc     eax
        cmp     cl,dl                          ;space
        jnz     Start0

Start3: mov     cl,[eax]
        inc     eax
        cmp     cl,dl                          ;space
        jz      Start3

        dec     eax

Start4: mov     lpCmndLine,eax

;------------------------------

        push    eax
        INVOKE  MessageBox,0,lpCmndLineFull,offset MsgStr,MB_ICONINFORMATION
        pop     eax

;------------------------------

        push    8
        mov     ebx,edi
        pop     ecx

Start5: movzx   edx,byte ptr [eax]
        sub     dl,30h
        cmp     dl,9
        jbe     Start6

        and     dl,0DFh
        sub     dl,7
        cmp     dl,0Fh
        ja      Start7

Start6: shl     ebx,4
        or      ebx,edx
        inc     eax
        loop    Start5

Start7: mov     hUsr,ebx

;------------------------------

;register the class for the window

        INVOKE  LoadIcon,edi,IDI_APPLICATION
        push    eax                                     ;WNDCLASSEX.hIconSm
        xchg    eax,ebx                                                           ;save hIcon in EBX for later
        mov     esi,offset ClassName                                              ;ClassName address in ESI
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        INVOKE  LoadCursor,edi,IDC_ARROW
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        push    eax                                     ;WNDCLASSEX.hInstance
        xchg    eax,ebx                                                           ;now, EBX = hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset AppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebx,edi
        mov     hWin,eax
        xchg    eax,ebx
        INVOKE  UpdateWindow,ebx

;------------------------------

;send the window handle to the user app (hidden window)

        push    ebx                                    ;Data
        mov     eax,hUsr
        push    esp                                    ;COPYDATASTRUCT.lpData
        push    4                                      ;COPYDATASTRUCT.cbData
        push    eax                                    ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,eax,WM_COPYDATA,ebx,esp

;------------------------------

;message loop

        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,esp
        INVOKE  DispatchMessage,esp

mLoop1: mov     eax,esp
        INVOKE  GetMessage,eax,edi,edi,edi
        inc     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop0                             ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                ;adjust the stack so that MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

