
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;###############################################################################################

        .DATA

        ALIGN   4

CdProc    dd CdInit
hPma      dd 0
ClassName db 'dTestUser',0
PmAppName db 'PmApp.exe '
PmCmdLine db 9 dup(0)
MsgStr    db 'Handle Received From PM Window',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance dd ?
hWin      dd ?
PrcInfo   PROCESS_INFORMATION <>
SuInfo    STARTUPINFO <>

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                      ;uMsg
        cmp     ecx,WM_COPYDATA
        jz      WndPr1

        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret     16

;------------------------------

;WM_COPYDATA

WndPr1: push    ebx
        mov     edx,[esp+20]                     ;EDX = lParam
        mov     ebx,[esp+8]                      ;EBX = hWnd aka hUsr
        cmp     ebx,[edx].COPYDATASTRUCT.dwData  ;dwData = hUsr
        jnz     WndPr2

        mov     ecx,[esp+16]                     ;ECX = wParam
        call dword ptr CdProc
        pop     ebx
        ret     16

WndPr2: pop     ebx
        jmp     WndPr0

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,[esp+4]            ;hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

CdInit  PROC

;EBX = hWnd
;ECX = wParam (sending window hWnd aka hPma)
;EDX = lParam (structure address)

        cmp     [edx].COPYDATASTRUCT.cbData,4
        jnz     CdIni0

        mov     edx,[edx].COPYDATASTRUCT.lpData      ;EDX = lpData
        cmp     ecx,[edx]                            ;Data = hPma
        jnz     CdIni0

        push    1
        mov     hPma,ecx
        INVOKE  MessageBox,ebx,uhex$(ecx),offset MsgStr,MB_ICONINFORMATION
        pop     eax
        ret

CdIni0: xor     eax,eax
        ret

CdInit  ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;register the window class

;we create the WNDCLASSEX structure on the stack by pushing members in reverse
;the same stack space is later used for the message loop MSG structure

        xor     edi,edi
        mov     esi,offset ClassName                                              ;ClassName address in ESI
        push    edi                                     ;WNDCLASSEX.hIconSm
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        push    edi                                     ;WNDCLASSEX.hCursor
        push    edi                                     ;WNDCLASSEX.hIcon
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        push    eax                                     ;WNDCLASSEX.hInstance
        xchg    eax,ebx                                                           ;EBX = hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,edi,
                WS_OVERLAPPED or WS_VISIBLE,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebx,edi
        mov     hWin,eax

;------------------------------

;execute the presentation manager app

        INVOKE  crt__ultoa,eax,offset PmCmdLine,16      ;pass hWin to the PM on the command line as ASCII hex
        push    (sizeof STARTUPINFO-4)/4
        push    sizeof STARTUPINFO
        mov     edi,offset SuInfo
        pop     eax
        mov     edx,edi
        pop     ecx
        stosd
        xor     eax,eax
        rep     stosd
        xchg    eax,edi
        INVOKE  CreateProcess,edi,offset PmAppName,edi,edi,edi,
                CREATE_NEW_PROCESS_GROUP or NORMAL_PRIORITY_CLASS,
                edi,edi,edx,offset PrcInfo

;------------------------------

;message loop

        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,esp
        INVOKE  DispatchMessage,esp

mLoop1: mov     eax,esp
        INVOKE  GetMessage,eax,edi,edi,edi
        inc     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop0                             ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                ;adjust the stack so that MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

